package builtin;

import runEnv.*;

public abstract class Component extends Thread {

	private boolean changed = false;
	private RunEnv runEnv;
	public RunEnv runEnv() { return runEnv; }

	
	public Component( RunEnv runEnv ) {
		this.runEnv = runEnv;
		runEnv.addListener( this );
		}
	
	public void run() {
		while ( true ) {
			compute();
			pause();
			}
		}
	
	public abstract void compute();
	
	public synchronized void pause() {
		if ( ! changed )
			try {
				wait();
				}
			catch ( InterruptedException exception ) {
				}
		changed = false;
		}
		
	public synchronized void schedule() {
		changed = true;
		notify();
		}
	}
