package builtin;

import runEnv.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

public class CounterComponent extends Component {

	JFrame frame;
	JTextField textField;
	JButton button;

	private ActionListener textInfoListener = new ActionListener() {
		public void actionPerformed( ActionEvent event ) {
			schedule();
			}
		};
	
	private ActionListener buttonListener = new ActionListener() {
		public void actionPerformed( ActionEvent event ) {
			int base = runEnv().getValue( "base" ).intValue();
			int n = runEnv().getValue( "n" ).intValue();
			try {
				long litValue = Long.parseLong( textField.getText(), base );
				litValue = ( litValue + 1 ) % ( 1L << n );
				textField.setText( Long.toString( litValue, base ) );
				}
			catch ( NumberFormatException exception ) {
				}
			schedule();
			}
		};
	
	public CounterComponent( RunEnv runEnv ) {
		super( runEnv );
		String name = runEnv().getValue( "name" ).stringValue();
		int x = runEnv().getValue( "x" ).intValue();
		int y = runEnv().getValue( "y" ).intValue();
		frame = new JFrame( name );
		textField = new JTextField( 20 );
		textField.setText( "0" );
		button = new JButton( "Step" );
		Container contentPane = frame.getContentPane();
		contentPane.setLayout( new FlowLayout() );
		textField.addActionListener( textInfoListener );
		button.addActionListener( buttonListener );
		contentPane.add( textField );
		contentPane.add( button );
		frame.setLocation( x, y );
		frame.validate();
		frame.pack();
		frame.setVisible( true );
		frame.toFront();
		}
	
	public void compute() {
//		System.err.println( "Compute CounterComponent" );
		int base = runEnv().getValue( "base" ).intValue();
		int n = runEnv().getValue( "n" ).intValue();
		PathArrayValue result = runEnv().getValue( "result" ).pathArrayValue();
		try {
			long litValue = Long.parseLong( textField.getText(), base );
			result.setValue( litValue % ( 1L << n ) );
			}
		catch ( NumberFormatException exception ) {
			}
		}
	
	public String toString() {
		String name = runEnv().getValue( "name" ).stringValue();
		return name;
		}
	
	}
