package node.declNode.pathDefnNode;

import node.exprNode.*;

import runEnv.*;

public class ArrayPathDefnNode extends PathDefnNode {

	private ExprNode size;

	public ArrayPathDefnNode( 
		String ident,
		ExprNode size ) {
		this.ident = ident;
		this.size = size;
		}

	public String toString() {
		return ident + "[ " + size + " ]";
		}

	public PathArrayValue eval( 
		int kind, 
		RunEnv runEnv, 
		PathArrayValue value ) {
		int sizeValue = size.eval( runEnv ).intValue();
		if ( value == null )
			value = new PathArrayValue( sizeValue );
		if ( value.size() != sizeValue )
			throw new Error( "Incompatible parameter " + value 
				+ " for " + ident + "[ " + sizeValue + " ]" );
		runEnv.declare( kind, ident, value );
		return value;
		}

	}