package node.exprNode.binaryNode.stringNode;

import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;

import runEnv.*;
import runEnv.basicValue.*;

public class ConcatStringNode extends BinaryNode {

	public ConcatStringNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_ADD;
		operator = "&";
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		return new StringValue( leftValue.stringValue() + rightValue.stringValue() );
		}
	}
