package node.stmtNode.invocationStmtNode;

import node.stmtNode.*;
import node.exprNode.*;
import node.pathNode.*;
import node.declNode.componentDeclNode.*;
import node.declNode.pathDefnNode.*;
import node.declNode.valueDefnNode.*;

import runEnv.*;

public class InvocationStmtNode extends StmtNode {

	private PathArrayListNode inputParams;
	private InvocNode invoc;
	private PathArrayListNode outputParams;

	public InvocationStmtNode( 
		PathArrayListNode inputParams, 
		InvocNode invoc, 
		PathArrayListNode outputParams ) {
		this.inputParams = inputParams;
		this.invoc = invoc;
		this.outputParams = outputParams;
		}

	public String toString() {
		throw new Error( "InvocationStmtNode.toString() Unimplemented" );
		}

	public void eval( RunEnv runEnv ) {
		PathArrayValue[] inputParamValues = inputParams.eval( runEnv );
		PathArrayValue[] outputParamValues = outputParams.eval( runEnv );
		invoc.eval( runEnv, inputParamValues, outputParamValues );
		}

	}
