package runEnv.basicValue;

import runEnv.*;
import builtin.*;

import java.util.*;
 
public class PathValue extends BasicValue {
	
	private static int pathNumGenerator = 0;
	
	private int pathNum;
	private boolean value;
	private Vector< Component > listeners = new Vector< Component >();

	public PathValue( int pathNum ) {
		this.pathNum = pathNum;
		}

	public PathValue() {
		this.pathNum = pathNumGenerator++;
		}

	public PathValue pathValue() {
		return this;
		}

	public int pathNum() {
		return pathNum;
		}

	public boolean isPath() {
		return true;
		}

	public boolean equals( Object other ) {
		if ( other == null )
			return false;
		if ( ! ( other instanceof RunValue ) )
			return false;
		RunValue runValue = ( RunValue ) other;
		if ( ! ( runValue instanceof PathValue ) )
			return false;
		PathValue otherPathValue = ( PathValue ) runValue;
		return pathNum() == otherPathValue.pathNum();
		}

	public String toString() {
		return "" + pathNum;
		}
	
	public boolean getValue() {
		return value;
		}
	
	public void setValue( boolean value ) {
//		System.err.println( "setValue " + value + " for " + this );
		if ( value != this.value ) {
			this.value = value;
			for ( int i = 0; i < listeners.size(); i++ ) {
				Component component = listeners.elementAt( i );
				component.schedule();
				}
			}
		}

	public void addListener( Component component ) {
//		System.err.println( "addListener " + component + " for " + this );
		listeners.add( component );
		}

	}
